.nolist
#include "ti83plus.inc"
.org userMem-2
.db $BB,$6D
.list
	bcall(_clrLCDFull)	;clear the LCD
	bcall(_homeup)		;put the cursor position in the top left corner
	bcall(_zeroop1)		;zero op1
	ld hl,stringname	;load string data
	rst 20h			;copy it to op1
	bcall(_chkFindSym)	;look it up
	jp c,stringnotfound	;if is doesn't exist goto stringnotfound
	ex de,hl		;hl now points to first size byte
	ld c,(hl)		;load c with least significant byte
	inc hl			;increment address
	ld b,(hl)		;load b with most significant byte
	inc hl			;increment address 
	ld de,appbackupscreen+1	;load de with address of the appbackupscreen with a one byte offset
	ldir			;copy data from str0 to appbackupscreen
	xor a			;zero register a
	ld (de),a		;add zero terminator to string data
	ld hl,text1		;load first text data
	bcall(_puts)		;place it
	ld a,2			;load a with 2
	ld (currow),a		;load cursor row with 2
	ld hl,text2		;load 2nd text data
	bcall(_puts)		;place it
Getkey:
	bcall(_Getkey)		;wait for keypress
	ld hl,appbackupscreen	;get address of appbackupscreen for later
	cp k1			;see if the 1 key was pressed
	jr z,progtoappvar	;if it was jump to label progtoappvar
	cp k2			;see if the 2 key was pressed
	jr z,appvartoprog	;if it was jump to label appvartoprog
	cp kclear		;see if the clear key was pressed
	jr z,exit		;if it was jump to label exit
	jr Getkey		;if none of the above keys were pressed jump back to Getkey
exit:
	bcall(_clrLCDFull)	;clear the LCD
	ret			;return to TIOS
progtoappvar:
	ld (hl),progobj		;load first byte of appbackupscreen with progobj
	ld a,appvarobj		;load a with appvarobj
	jr switch		;jump to switch
appvartoprog:
	ld (hl),appvarobj
	bcall(_clrLCDFull)
	bcall(_homeup)
	ld hl,text5
	bcall(_puts)
	xor a
	ld (curcol),a
	ld a,2
	ld (currow),a
	ld hl,text6
	bcall(_puts)
	bcall(_newline)
	ld hl,text7
	bcall(_puts)
	bcall(_getkey)
	cp k1
	jr z,appvartoprog2
	cp k2
	jr z,appvartoprotprog
	ret
appvartoprog2:
	ld a,progobj
	jr switch
appvartoprotprog:
	ld a,protprogobj	
switch:
	push af			;push object type onto the stack for later 
	bcall(_zeroop1)		;zero op1
	ld hl,appbackupscreen	;load hl with address of appbackupscreen
	rst 20h			;copy data to op1
	bcall(_chkFindSym)	;look it up
	jr c,error		;if it doesn't exist jump to error
	pop af			;restore object type
	ld (hl),a		;load object byte of program data with object type stored in a
	ret			;return to the TIOS
stringnotfound:
	ld hl,text3		;load text 3
	bcall(_puts)		;place it
	bcall(_Getkey)		;wait for keypress
	ret			;return to TIOS
error:
	pop af			;pop af off the stack so as to prevent a crash
	bcall(_clrLCDFull)	;clear the LCD
	bcall(_homeup)		;place cursor in top left corner
	ld hl,text4		;load text 4
	bcall(_puts)		;place it
	bcall(_newline)		;shift a line down
	ret			;return to the TIOS

text1:
	.db "Program<->Appvar",0
text2:
	.db "1)Prog to appvar"
	.db "2)appvar to Prog",0
text3:
	.db "Str0 not found",0
text4:
	.db " File specified "
	.db " does not exist "
	.db " or has already "
	.db " been converted",0
text5:
	.db "What type?",0
text6:
	.db "1) Unprotected",0
text7:
	.db "2) Protected",0

stringname:
	.db Strngobj,tvarstrng,tstr0,0	;string data

.end				;end of code